/* AlertView.c generated by valac 0.56.14, the Vala compiler
 * generated from AlertView.vala, do not modify */

/*
 *  Copyright (C) 2012-2017 Granite Developers (https://launchpad.net/granite)
 *
 *  This program or library is free software; you can redistribute it
 *  and/or modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 3 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General
 *  Public License along with this library; if not, write to the
 *  Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 *  Boston, MA 02110-1301 USA.
 *
 *  Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <pango/pango.h>
#include <float.h>
#include <math.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define CLIPPED_WIDGETS_TYPE_ALERT_VIEW (clipped_widgets_alert_view_get_type ())
#define CLIPPED_WIDGETS_ALERT_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CLIPPED_WIDGETS_TYPE_ALERT_VIEW, ClippedWidgetsAlertView))
#define CLIPPED_WIDGETS_ALERT_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CLIPPED_WIDGETS_TYPE_ALERT_VIEW, ClippedWidgetsAlertViewClass))
#define CLIPPED_WIDGETS_IS_ALERT_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CLIPPED_WIDGETS_TYPE_ALERT_VIEW))
#define CLIPPED_WIDGETS_IS_ALERT_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CLIPPED_WIDGETS_TYPE_ALERT_VIEW))
#define CLIPPED_WIDGETS_ALERT_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CLIPPED_WIDGETS_TYPE_ALERT_VIEW, ClippedWidgetsAlertViewClass))

typedef struct _ClippedWidgetsAlertView ClippedWidgetsAlertView;
typedef struct _ClippedWidgetsAlertViewClass ClippedWidgetsAlertViewClass;
typedef struct _ClippedWidgetsAlertViewPrivate ClippedWidgetsAlertViewPrivate;
enum  {
	CLIPPED_WIDGETS_ALERT_VIEW_0_PROPERTY,
	CLIPPED_WIDGETS_ALERT_VIEW_TITLE_PROPERTY,
	CLIPPED_WIDGETS_ALERT_VIEW_DESCRIPTION_PROPERTY,
	CLIPPED_WIDGETS_ALERT_VIEW_ICON_NAME_PROPERTY,
	CLIPPED_WIDGETS_ALERT_VIEW_NUM_PROPERTIES
};
static GParamSpec* clipped_widgets_alert_view_properties[CLIPPED_WIDGETS_ALERT_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _ClippedWidgetsAlertView {
	GtkGrid parent_instance;
	ClippedWidgetsAlertViewPrivate * priv;
};

struct _ClippedWidgetsAlertViewClass {
	GtkGridClass parent_class;
};

struct _ClippedWidgetsAlertViewPrivate {
	GtkLabel* title_label;
	GtkLabel* description_label;
	GtkImage* image;
};

static gint ClippedWidgetsAlertView_private_offset;
static gpointer clipped_widgets_alert_view_parent_class = NULL;

VALA_EXTERN GType clipped_widgets_alert_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ClippedWidgetsAlertView, g_object_unref)
VALA_EXTERN ClippedWidgetsAlertView* clipped_widgets_alert_view_new (const gchar* title,
                                                         const gchar* description,
                                                         const gchar* icon_name);
VALA_EXTERN ClippedWidgetsAlertView* clipped_widgets_alert_view_construct (GType object_type,
                                                               const gchar* title,
                                                               const gchar* description,
                                                               const gchar* icon_name);
VALA_EXTERN const gchar* clipped_widgets_alert_view_get_title (ClippedWidgetsAlertView* self);
VALA_EXTERN void clipped_widgets_alert_view_set_title (ClippedWidgetsAlertView* self,
                                           const gchar* value);
VALA_EXTERN const gchar* clipped_widgets_alert_view_get_description (ClippedWidgetsAlertView* self);
VALA_EXTERN void clipped_widgets_alert_view_set_description (ClippedWidgetsAlertView* self,
                                                 const gchar* value);
VALA_EXTERN gchar* clipped_widgets_alert_view_get_icon_name (ClippedWidgetsAlertView* self);
VALA_EXTERN void clipped_widgets_alert_view_set_icon_name (ClippedWidgetsAlertView* self,
                                               const gchar* value);
static GObject * clipped_widgets_alert_view_constructor (GType type,
                                                  guint n_construct_properties,
                                                  GObjectConstructParam * construct_properties);
static void clipped_widgets_alert_view_finalize (GObject * obj);
static GType clipped_widgets_alert_view_get_type_once (void);
static void _vala_clipped_widgets_alert_view_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec);
static void _vala_clipped_widgets_alert_view_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec);

static inline gpointer
clipped_widgets_alert_view_get_instance_private (ClippedWidgetsAlertView* self)
{
	return G_STRUCT_MEMBER_P (self, ClippedWidgetsAlertView_private_offset);
}

/**
     * Makes new AlertView
     *
     * @param title the first line of text
     * @param description the second line of text
     * @param icon_name the icon to be shown
     */
ClippedWidgetsAlertView*
clipped_widgets_alert_view_construct (GType object_type,
                                      const gchar* title,
                                      const gchar* description,
                                      const gchar* icon_name)
{
	ClippedWidgetsAlertView * self = NULL;
	g_return_val_if_fail (title != NULL, NULL);
	g_return_val_if_fail (description != NULL, NULL);
	g_return_val_if_fail (icon_name != NULL, NULL);
	self = (ClippedWidgetsAlertView*) g_object_new (object_type, "title", title, "description", description, "icon-name", icon_name, NULL);
	return self;
}

ClippedWidgetsAlertView*
clipped_widgets_alert_view_new (const gchar* title,
                                const gchar* description,
                                const gchar* icon_name)
{
	return clipped_widgets_alert_view_construct (CLIPPED_WIDGETS_TYPE_ALERT_VIEW, title, description, icon_name);
}

const gchar*
clipped_widgets_alert_view_get_title (ClippedWidgetsAlertView* self)
{
	const gchar* result;
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->title_label;
	_tmp1_ = gtk_label_get_label (_tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

void
clipped_widgets_alert_view_set_title (ClippedWidgetsAlertView* self,
                                      const gchar* value)
{
	GtkLabel* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->title_label;
	gtk_label_set_label (_tmp0_, value);
	g_object_notify_by_pspec ((GObject *) self, clipped_widgets_alert_view_properties[CLIPPED_WIDGETS_ALERT_VIEW_TITLE_PROPERTY]);
}

const gchar*
clipped_widgets_alert_view_get_description (ClippedWidgetsAlertView* self)
{
	const gchar* result;
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->description_label;
	_tmp1_ = gtk_label_get_label (_tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

void
clipped_widgets_alert_view_set_description (ClippedWidgetsAlertView* self,
                                            const gchar* value)
{
	GtkLabel* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->description_label;
	gtk_label_set_label (_tmp0_, value);
	g_object_notify_by_pspec ((GObject *) self, clipped_widgets_alert_view_properties[CLIPPED_WIDGETS_ALERT_VIEW_DESCRIPTION_PROPERTY]);
}

gchar*
clipped_widgets_alert_view_get_icon_name (ClippedWidgetsAlertView* self)
{
	gchar* result;
	GtkImage* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->image;
	g_object_get (_tmp0_, "icon-name", &_tmp1_, NULL);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

void
clipped_widgets_alert_view_set_icon_name (ClippedWidgetsAlertView* self,
                                          const gchar* value)
{
	GtkImage* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->image;
	gtk_image_set_from_icon_name (_tmp0_, value, (GtkIconSize) GTK_ICON_SIZE_DIALOG);
	g_object_notify_by_pspec ((GObject *) self, clipped_widgets_alert_view_properties[CLIPPED_WIDGETS_ALERT_VIEW_ICON_NAME_PROPERTY]);
}

static GObject *
clipped_widgets_alert_view_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ClippedWidgetsAlertView * self;
	GtkStyleContext* _tmp0_;
	GtkLabel* _tmp1_;
	GtkLabel* _tmp2_;
	GtkLabel* _tmp3_;
	GtkStyleContext* _tmp4_;
	GtkLabel* _tmp5_;
	GtkLabel* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	GtkLabel* _tmp9_;
	GtkLabel* _tmp10_;
	GtkLabel* _tmp11_;
	GtkLabel* _tmp12_;
	GtkLabel* _tmp13_;
	GtkLabel* _tmp14_;
	GtkImage* _tmp15_;
	GtkEventBox* image_box = NULL;
	GtkEventBox* _tmp16_;
	GtkEventBox* _tmp17_;
	GtkEventBox* _tmp18_;
	GtkEventBox* _tmp19_;
	GtkImage* _tmp20_;
	GtkEventBox* _tmp21_;
	GtkLabel* _tmp22_;
	GtkLabel* _tmp23_;
	parent_class = G_OBJECT_CLASS (clipped_widgets_alert_view_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CLIPPED_WIDGETS_TYPE_ALERT_VIEW, ClippedWidgetsAlertView);
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp0_, GTK_STYLE_CLASS_VIEW);
	_tmp1_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp1_);
	_g_object_unref0 (self->priv->title_label);
	self->priv->title_label = _tmp1_;
	_tmp2_ = self->priv->title_label;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp2_, TRUE);
	_tmp3_ = self->priv->title_label;
	_tmp4_ = gtk_widget_get_style_context ((GtkWidget*) _tmp3_);
	gtk_style_context_add_class (_tmp4_, "h2");
	_tmp5_ = self->priv->title_label;
	gtk_label_set_max_width_chars (_tmp5_, 45);
	_tmp6_ = self->priv->title_label;
	g_object_set (_tmp6_, "wrap", TRUE, NULL);
	_tmp7_ = self->priv->title_label;
	g_object_set (_tmp7_, "wrap-mode", PANGO_WRAP_WORD_CHAR, NULL);
	_tmp8_ = self->priv->title_label;
	gtk_label_set_xalign (_tmp8_, (gfloat) 0);
	_tmp9_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp9_);
	_g_object_unref0 (self->priv->description_label);
	self->priv->description_label = _tmp9_;
	_tmp10_ = self->priv->description_label;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp10_, TRUE);
	_tmp11_ = self->priv->description_label;
	g_object_set (_tmp11_, "wrap", TRUE, NULL);
	_tmp12_ = self->priv->description_label;
	gtk_label_set_use_markup (_tmp12_, TRUE);
	_tmp13_ = self->priv->description_label;
	gtk_label_set_xalign (_tmp13_, (gfloat) 0);
	_tmp14_ = self->priv->description_label;
	gtk_widget_set_valign ((GtkWidget*) _tmp14_, GTK_ALIGN_START);
	_tmp15_ = (GtkImage*) gtk_image_new ();
	g_object_ref_sink (_tmp15_);
	_g_object_unref0 (self->priv->image);
	self->priv->image = _tmp15_;
	_tmp16_ = (GtkEventBox*) gtk_event_box_new ();
	g_object_ref_sink (_tmp16_);
	image_box = _tmp16_;
	_tmp17_ = image_box;
	gtk_widget_set_margin_top ((GtkWidget*) _tmp17_, 6);
	_tmp18_ = image_box;
	gtk_widget_set_valign ((GtkWidget*) _tmp18_, GTK_ALIGN_START);
	_tmp19_ = image_box;
	_tmp20_ = self->priv->image;
	gtk_container_add ((GtkContainer*) _tmp19_, (GtkWidget*) _tmp20_);
	gtk_grid_set_column_spacing ((GtkGrid*) self, 12);
	gtk_grid_set_row_spacing ((GtkGrid*) self, 6);
	gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_CENTER);
	gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_CENTER);
	gtk_widget_set_vexpand ((GtkWidget*) self, TRUE);
	g_object_set ((GtkWidget*) self, "margin", 24, NULL);
	_tmp21_ = image_box;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp21_, 1, 1, 1, 2);
	_tmp22_ = self->priv->title_label;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp22_, 2, 1, 1, 1);
	_tmp23_ = self->priv->description_label;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp23_, 2, 2, 1, 1);
	_g_object_unref0 (image_box);
	return obj;
}

static void
clipped_widgets_alert_view_class_init (ClippedWidgetsAlertViewClass * klass,
                                       gpointer klass_data)
{
	clipped_widgets_alert_view_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &ClippedWidgetsAlertView_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_clipped_widgets_alert_view_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_clipped_widgets_alert_view_set_property;
	G_OBJECT_CLASS (klass)->constructor = clipped_widgets_alert_view_constructor;
	G_OBJECT_CLASS (klass)->finalize = clipped_widgets_alert_view_finalize;
	/**
	     * The first line of text, should be short and not contain markup.
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), CLIPPED_WIDGETS_ALERT_VIEW_TITLE_PROPERTY, clipped_widgets_alert_view_properties[CLIPPED_WIDGETS_ALERT_VIEW_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	     * The second line of text, explaining why this alert is shown.
	     * You may need to escape it with #escape_text or #printf_escaped
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), CLIPPED_WIDGETS_ALERT_VIEW_DESCRIPTION_PROPERTY, clipped_widgets_alert_view_properties[CLIPPED_WIDGETS_ALERT_VIEW_DESCRIPTION_PROPERTY] = g_param_spec_string ("description", "description", "description", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	     * The icon name
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), CLIPPED_WIDGETS_ALERT_VIEW_ICON_NAME_PROPERTY, clipped_widgets_alert_view_properties[CLIPPED_WIDGETS_ALERT_VIEW_ICON_NAME_PROPERTY] = g_param_spec_string ("icon-name", "icon-name", "icon-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
clipped_widgets_alert_view_instance_init (ClippedWidgetsAlertView * self,
                                          gpointer klass)
{
	self->priv = clipped_widgets_alert_view_get_instance_private (self);
}

static void
clipped_widgets_alert_view_finalize (GObject * obj)
{
	ClippedWidgetsAlertView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CLIPPED_WIDGETS_TYPE_ALERT_VIEW, ClippedWidgetsAlertView);
	_g_object_unref0 (self->priv->title_label);
	_g_object_unref0 (self->priv->description_label);
	_g_object_unref0 (self->priv->image);
	G_OBJECT_CLASS (clipped_widgets_alert_view_parent_class)->finalize (obj);
}

static GType
clipped_widgets_alert_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ClippedWidgetsAlertViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) clipped_widgets_alert_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ClippedWidgetsAlertView), 0, (GInstanceInitFunc) clipped_widgets_alert_view_instance_init, NULL };
	GType clipped_widgets_alert_view_type_id;
	clipped_widgets_alert_view_type_id = g_type_register_static (gtk_grid_get_type (), "ClippedWidgetsAlertView", &g_define_type_info, 0);
	ClippedWidgetsAlertView_private_offset = g_type_add_instance_private (clipped_widgets_alert_view_type_id, sizeof (ClippedWidgetsAlertViewPrivate));
	return clipped_widgets_alert_view_type_id;
}

GType
clipped_widgets_alert_view_get_type (void)
{
	static volatile gsize clipped_widgets_alert_view_type_id__once = 0;
	if (g_once_init_enter (&clipped_widgets_alert_view_type_id__once)) {
		GType clipped_widgets_alert_view_type_id;
		clipped_widgets_alert_view_type_id = clipped_widgets_alert_view_get_type_once ();
		g_once_init_leave (&clipped_widgets_alert_view_type_id__once, clipped_widgets_alert_view_type_id);
	}
	return clipped_widgets_alert_view_type_id__once;
}

static void
_vala_clipped_widgets_alert_view_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec)
{
	ClippedWidgetsAlertView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CLIPPED_WIDGETS_TYPE_ALERT_VIEW, ClippedWidgetsAlertView);
	switch (property_id) {
		case CLIPPED_WIDGETS_ALERT_VIEW_TITLE_PROPERTY:
		g_value_set_string (value, clipped_widgets_alert_view_get_title (self));
		break;
		case CLIPPED_WIDGETS_ALERT_VIEW_DESCRIPTION_PROPERTY:
		g_value_set_string (value, clipped_widgets_alert_view_get_description (self));
		break;
		case CLIPPED_WIDGETS_ALERT_VIEW_ICON_NAME_PROPERTY:
		g_value_take_string (value, clipped_widgets_alert_view_get_icon_name (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_clipped_widgets_alert_view_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec)
{
	ClippedWidgetsAlertView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CLIPPED_WIDGETS_TYPE_ALERT_VIEW, ClippedWidgetsAlertView);
	switch (property_id) {
		case CLIPPED_WIDGETS_ALERT_VIEW_TITLE_PROPERTY:
		clipped_widgets_alert_view_set_title (self, g_value_get_string (value));
		break;
		case CLIPPED_WIDGETS_ALERT_VIEW_DESCRIPTION_PROPERTY:
		clipped_widgets_alert_view_set_description (self, g_value_get_string (value));
		break;
		case CLIPPED_WIDGETS_ALERT_VIEW_ICON_NAME_PROPERTY:
		clipped_widgets_alert_view_set_icon_name (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

